unit uVisibleColsTest;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.TMSBaseControl,
  FMX.TMSGridCell, FMX.TMSGridOptions, FMX.TMSGridData, FMX.TMSCustomGrid, FMX.TMSGrid,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts;

type
  TMyGridCol = (
    Fixed1,   // Col 0
    Fixed2,   // Col 1
    Data01,   // Col 2
    Data02,
    Data03,
    Data04,
    Data05,
    Data06,
    Data07,
    Data08,
    Data09,
    Data10,
    Data11,
    Data12,
    Data13,
    Data14    // Col 15
  );          // maximum visible column count: 16 columns

  TForm1 = class(TForm)
    TestGrid: TTMSFMXGrid;
    Layout1: TLayout;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
  private
    procedure SetupGrid;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy(); override;
  end;

var
  Form1: TForm1;

implementation

uses
  System.TypInfo;

{$R *.fmx}

{ TForm1 }

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  TestGrid.NeedStyleLookup;
  TestGrid.ApplyStyleLookup;
  SetupGrid;
end;

destructor TForm1.Destroy;
begin

  inherited;
end;

procedure TForm1.SetupGrid;
var
  LCol: TMyGridCol;
begin
  TestGrid.ColumnCount := Succ( Ord(High(TMyGridCol)) );

  Label1.Text := Format(
    'Before Hide 3 Columns - Column Count: %d - (Expected: %d)',[TestGrid.ColumnCount,Succ( Ord(High(TMyGridCol)) )]
  );

  TestGrid.FixedColumns := Succ(Ord(TMyGridCol.Fixed2));
  TestGrid.RowCount := 8; // doesn't matter
  for LCol := Low(TMyGridCol) to High(TMyGridCol) do begin
    TestGrid.Cells[Ord(LCol),0] := Format('%s',[GetEnumName(TypeInfo(TMyGridCol),Ord(LCol))]);
  end;

  // hide cols Data05 (col 6), Data06 (col 7) and Data10 (col 11)

  TestGrid.HideColumn(Ord(TMyGridCol.Data05));
  TestGrid.HideColumn(Ord(TMyGridCol.Data06));
  TestGrid.HideColumn(Ord(TMyGridCol.Data10));

{
function TTMSFMXCustomGrid.VisibleColumnCount: Integer;
begin
  Result := FCStop - FCStart + FixedRightColumns + GetFixedCols + 1;
              0        0           0                     2        1
end;

}

  Label2.Text := Format(
    'After Hide 3 Columns - Column Count: %d (Expected: %d, 3 were hidden, not deleted)',
    [
      TestGrid.ColumnCount,
      Succ( Ord(High(TMyGridCol)) )
    ]
  );
  Label3.Text := Format('Hidden Column Count: %d - Expected 3',[TestGrid.HiddenColumnCount]);

  Label4.Text := Format(
    'Visible Column Count: %d - Expected :%d (%d - %d)',
    [
      TestGrid.VisibleColumnCount,
      Succ( Ord(High(TMyGridCol)) ) - TestGrid.HiddenColumnCount,
      Succ( Ord(High(TMyGridCol)) ),
      TestGrid.HiddenColumnCount
    ]
  );

end;

end.
